using System;
using System.Drawing;
using System.Diagnostics;
using System.Data;
using Microsoft.VisualBasic;
using System.Collections;
using System.Windows.Forms;

using System.IO;
using Dir2Files;



// EJERCICIO BASADO EN OTRO DE DAMIAN CASTROVIEJO TITULADO
// --- How to use a recursive function to read a directory structure and save it to XML ---

// Espacio de nombres con las clases DirectoryInfo y FileInfo
namespace Dir2Files
{
	
	public class Form1 : System.Windows.Forms.Form
	{
		[STAThread]
		static void Main()
		{
			System.Windows.Forms.Application.Run(new Form1());
		}
		
#region  Código generado por el Diseñador de Windows Forms
		
		public Form1()
		{
			
			//El Diseñador de Windows Forms requiere esta llamada.
			InitializeComponent();
			
			//Agregar cualquier inicialización después de la llamada a InitializeComponent()
			
		}
		
		//Form reemplaza a Dispose para limpiar la lista de componentes.
		protected override void Dispose(bool disposing)
		{
			if (disposing)
			{
				if (!(ReferenceEquals(components, null)))
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}
		
		//Requerido por el Diseñador de Windows Forms
		private System.ComponentModel.Container components = null;
		
		//NOTA: el Diseñador de Windows Forms requiere el siguiente procedimiento
		//Puede modificarse utilizando el Diseñador de Windows Forms.
		//No lo modifique con el editor de código.
		internal System.Windows.Forms.FolderBrowserDialog folderDlg;
		internal System.Windows.Forms.Button BtAbrir;
		internal System.Windows.Forms.Button BtSalir;
		internal System.Windows.Forms.Button BtListBox;
		internal System.Windows.Forms.ListBox listBox;
		internal System.Windows.Forms.Button BtDesc1;
		internal System.Windows.Forms.Button btExt1;
		internal System.Windows.Forms.Button BtAsc1;
		internal Label lblList;
		internal System.Windows.Forms.TextBox txtExt1;
		[System.Diagnostics.DebuggerStepThrough()]private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Form1));
            this.folderDlg = new System.Windows.Forms.FolderBrowserDialog();
            this.BtAbrir = new System.Windows.Forms.Button();
            this.BtSalir = new System.Windows.Forms.Button();
            this.BtListBox = new System.Windows.Forms.Button();
            this.BtDesc1 = new System.Windows.Forms.Button();
            this.btExt1 = new System.Windows.Forms.Button();
            this.BtAsc1 = new System.Windows.Forms.Button();
            this.txtExt1 = new System.Windows.Forms.TextBox();
            this.listBox = new System.Windows.Forms.ListBox();
            this.lblList = new System.Windows.Forms.Label();
            this.SuspendLayout();
            // 
            // folderDlg
            // 
            resources.ApplyResources(this.folderDlg, "folderDlg");
            // 
            // BtAbrir
            // 
            resources.ApplyResources(this.BtAbrir, "BtAbrir");
            this.BtAbrir.Name = "BtAbrir";
            this.BtAbrir.Click += new System.EventHandler(this.BtAbrir_Click);
            // 
            // BtSalir
            // 
            resources.ApplyResources(this.BtSalir, "BtSalir");
            this.BtSalir.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.BtSalir.Name = "BtSalir";
            this.BtSalir.Click += new System.EventHandler(this.BtSalir_Click);
            // 
            // BtListBox
            // 
            resources.ApplyResources(this.BtListBox, "BtListBox");
            this.BtListBox.Name = "BtListBox";
            this.BtListBox.Click += new System.EventHandler(this.BtListBox_Click);
            // 
            // BtDesc1
            // 
            resources.ApplyResources(this.BtDesc1, "BtDesc1");
            this.BtDesc1.Name = "BtDesc1";
            this.BtDesc1.Click += new System.EventHandler(this.BtDesc1_Click);
            // 
            // btExt1
            // 
            resources.ApplyResources(this.btExt1, "btExt1");
            this.btExt1.Name = "btExt1";
            this.btExt1.Click += new System.EventHandler(this.BtExtension_Click);
            // 
            // BtAsc1
            // 
            resources.ApplyResources(this.BtAsc1, "BtAsc1");
            this.BtAsc1.Name = "BtAsc1";
            this.BtAsc1.Click += new System.EventHandler(this.BtAsc1_Click);
            // 
            // txtExt1
            // 
            resources.ApplyResources(this.txtExt1, "txtExt1");
            this.txtExt1.Name = "txtExt1";
            // 
            // listBox
            // 
            resources.ApplyResources(this.listBox, "listBox");
            this.listBox.BackColor = System.Drawing.Color.Navy;
            this.listBox.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.listBox.ForeColor = System.Drawing.Color.White;
            this.listBox.Name = "listBox";
            this.listBox.TabStop = false;
            // 
            // lblList
            // 
            resources.ApplyResources(this.lblList, "lblList");
            this.lblList.Name = "lblList";
            // 
            // Form1
            // 
            resources.ApplyResources(this, "$this");
            this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Dpi;
            this.CancelButton = this.BtSalir;
            this.Controls.Add(this.lblList);
            this.Controls.Add(this.BtDesc1);
            this.Controls.Add(this.BtListBox);
            this.Controls.Add(this.listBox);
            this.Controls.Add(this.BtSalir);
            this.Controls.Add(this.BtAbrir);
            this.Controls.Add(this.BtAsc1);
            this.Controls.Add(this.btExt1);
            this.Controls.Add(this.txtExt1);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "Form1";
            this.Load += new System.EventHandler(this.Form1_Load);
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		
#endregion
		
		// Variables visibles por toda la clase
		//
		// Ruta al directorio cuyos archivos van a ser listados
		private string strPath;
		// Matriz con las carpetas del directorio seleccionado
		private string[] strCarpeta;
		// Enteros para contar archivos
		private int n;
		private int i;
		private int j;
		// Variable a para saber si se ha seleccionado algún directorio o todavía no
		// Variable b para ordenar los archivos de forma ascendente o descendente
		private bool a;
		private bool b;
		// Enteros para contar el tiempo transcurrido en llevar a cabo un procedimiento
		private int inicio;
		private int final;
		
		// Al cargar el formulario: tamaño y posición (pos. horizontal = en el medio) (alto = alto de la pantalla - 140 px)
		private void Form1_Load(System.Object sender, System.EventArgs e)
		{
			this.Left = System.Convert.ToInt32((Screen.PrimaryScreen.WorkingArea.Width - this.Width) / 2);
			this.Top = 70;
			this.Height = (Screen.PrimaryScreen.WorkingArea.Height) - 140;
			this.Width = 535;
		}
		
		private void BtAbrir_Click(System.Object sender, System.EventArgs e)
		{
			AbrirCarpeta(); // procedimiento que se encarga de elegir el directorio
		}
		
		// PROCEDIMIENTO QUE SE ENCARGA DE ELEGIR EL DIRECTORIO
		private void AbrirCarpeta()
		{
			try
			{
				// Cuadro de diálogo de selección de carpeta (FolderBrowserDialog)
				if (folderDlg.ShowDialog() == System.Windows.Forms.DialogResult.OK)
				{
					// strPath contiene la ruta al directorio elegido y strCarpeta una matriz con sus archivos
					strPath = folderDlg.SelectedPath;
				}
				strCarpeta = System.IO.Directory.GetFiles(strPath);
				//
				this.Text = "Dir2Files C#";
				// Mostrar la ruta completa al directorio
				lblList.Text = strPath;
				// Mostrar sólo el nombre del directorio, sin la ruta
				//lblList.Text = "" + strPath.Substring(strPath.LastIndexOf("\") + 1) + ""
				//
				// Para saber que ya se ha seleccionado un directorio
				a = true;
			}
			catch (Exception)
			{
				return ;
			}
		}
		
		// PROCEDIMIENTO QUE RELLENA EL CONTROL LISTBOX CON LOS ARCHIVOS
		// Y MUESTRA EL TIEMPO QUE TARDA EN LLEVARSE A CABO ESE PROCESO
		private void BtListBox_Click(System.Object sender, System.EventArgs e)
		{
			try
			{
				//
				if (a)
				{
					// Environment.TickCount devuelve el nº de milisegundos desde que se ha iniciado Windows
					// Calculando la propiedad TickCount al comienzo y al final del procedimiento vemos su duración
					// Es una forma poco elaborada de comparar el rendimiento de procedimientos diferentes
					inicio = System.Environment.TickCount;
                    //
                    // Rellenar el control ListBox llamando a la funcion recursiva ListarArchivos1
                    // a la que se le pasan 2 parámetros String:
                    //- nombre del directorio actual, cambia en cada pasada recursiva
                    //- ruta completa al directorio actual
                    // Al empezar la serie, ambas rutas coinciden (nombre y ruta del directorio actual)
                    listBox.Items.Clear();
					ListarArchivos1(strPath + "\\", strPath + "\\");
					//
					j = listBox.Items.Count;
					this.Text = "Archivos: " + Convert.ToString(j);
					//
					final = System.Environment.TickCount;
					// Información del tiempo empleado en rellenar el control ListBox
					MessageBox.Show("Tiempo utilizado en el proceso: " + Convert.ToString((double) (final - inicio) / 1000) + " segundos.");
				}
				//
			}
			catch (Exception pollo)
			{
				if (!(pollo.GetType().ToString() == "System.UnauthorizedAccessException"))
				{
					MessageBox.Show"Se ha producido una excepción:" + "\r\n" + pollo.GetType().ToString());
				}
			}
		}
		
		// FUNCION RECURSIVA QUE RELLENA EL CONTROL LISTBOX SÓLO CON NOMBRES DE ARCHIVOS
		// A LA FUNCIÓN SE LE PASAN 2 PARÁMETROS:
		//- NOMBRE DEL DIRECTORIO ACTUAL, CAMBIA EN CADA PASADA RECURSIVA
		//- RUTA COMPLETA AL DIRECTORIO ACTUAL
		private dynamic ListarArchivos1(string s, string strPath)
		{
			try
			{
				//
				this.Text = "Procesando el directorio elegido...";
				//
				// Variables para contener información sobre archivos y carpetas
				DirectoryInfo d = default(DirectoryInfo);
				DirectoryInfo ofs = new DirectoryInfo(strPath + "\\");
				FileInfo oFile = default(FileInfo);
				//
				// Bucle For Each para las carpetas: obtener todas las carpetas contenidas en el directorio seleccionado
				foreach (DirectoryInfo tempLoopVar_d in ofs.GetDirectories())
				{
					d = tempLoopVar_d;
					// Llamada recursiva (ListarArchivos1 es llamada desde dentro de ListarArchivos1)
					// Porque cada carpeta puede tener a su vez subcarpetas que también han de ser analizadas
					ListarArchivos1(d.Name, strPath + "\\" + d.Name);
				}
				//
				// Bucle For Each para los archivos: obtener todos los archivos existentes en cada una de las carpetas y añadirlos al ListBox
				// Este bucle no necesita llamadas recursivas porque un archivo no tiene subarchivos que recorrer
				foreach (FileInfo tempLoopVar_oFile in ofs.GetFiles())
				{
					oFile = tempLoopVar_oFile;
					// Distintas formas de mostrar la lista de archivos en el control ListBox
					//listBox.Items.Add((listBox.Items.Count + 1) + ". " + oFile.Name)
					//listBox.Items.Add(oFile.Name + " [" + (listBox.Items.Count + 1) + "]")
					listBox.Items.Add(oFile.Name);
				}
				//
			}
			catch (Exception pollo)
			{
				if (!(pollo.GetType().ToString() == "System.UnauthorizedAccessException"))
				{
					MessageBox.Show"Se ha producido una excepción:" + "\r\n" + pollo.GetType().ToString());
				}
			}
			return default(dynamic);
		}
		
		// ORDENAR EL CONTROL LISTBOX DE FORMA DESCENDENTE
		private void BtDesc1_Click(System.Object sender, System.EventArgs e)
		{
			if (a)
			{
				b = false;
				OrdenarLista1(listBox);
			}
		}
		
		// ORDENAR EL CONTROL LISTBOX DE FORMA ASCENDENTE
		private void BtAsc1_Click(System.Object sender, System.EventArgs e)
		{
			if (a)
			{
				b = true;
				OrdenarLista1(listBox);
			}
		}
		
		// ORDENAR EL CONTROL LISTVIEW USANDO UN ARRAYLIST
		private void OrdenarLista1(ListBox listBox)
		{
			try
			{
				//
				// El proceso de ordenar un ListBox es complejo por lo que se recurre a este "truco":
				// - utilizamos un ArrayList como almacén temporal de la lista de archivos del ListBox
				// - volcamos el contenido del ListBox al ArrayList
				// - vaciamos el ListBox
				// - ordenamos el Arraylist
				// - lo volcamos al ListBox con los elementos ordenados
				ArrayList matriz = new ArrayList();
				int indice = 0;
				//
				inicio = System.Environment.TickCount;
				//
				this.Text = "Procesando el directorio elegido...";
				//
				for (indice = 0; indice <= listBox.Items.Count - 1; indice++)
				{
					//matriz.Add(CStr(listBox.Items(indice)))
					matriz.Add(listBox.Items[indice]);
				}
				matriz.Sort();
				listBox.Items.Clear();
				//
				if (b == true)
				{
					// ordenar de manera ascendente
					for (indice = matriz.Count - 1; indice >= 0; indice--)
					{
						listBox.Items.Add(matriz[indice]);
					}
				}
				else
				{
					// ordenar de manera descendente
					for (indice = 0; indice <= matriz.Count - 1; indice++)
					{
						listBox.Items.Add(matriz[indice]);
					}
				}
				//
				this.Text = "Dir2Files C#";
				//
				final = System.Environment.TickCount;
				MessageBox.Show("Tiempo utilizado en el proceso: " + Convert.ToString((double) (final - inicio) / 1000) + " segundos.");
				//
			}
			catch (Exception pollo)
			{
				if (!(pollo.GetType().ToString() == "System.UnauthorizedAccessException"))
				{
					MessageBox.Show(System.Convert.ToString("Se ha producido una excepción:" + "\r\n" + pollo.GetType().ToString() +"."));
				}
			}
		}
		
		// LISTAR LOS ARCHIVOS CON UNA EXTENSIÓN DETERMINADA
		private void BtExtension_Click(System.Object sender, System.EventArgs e)
		{
			try
			{
				//
				// Si el cuadro de texto txtExt1 no está vacío
				if (txtExt1.Text.Length > 0)
				{
					//
					inicio = System.Environment.TickCount;
					//
					// rellenar el ListBox (para buscar siempre en la lista completa y no
					// en la de la extensión que se haya usado previamente)
					listBox.Items.Clear();
					ListarArchivos1(strPath + "\\", strPath + "\\");
					j = listBox.Items.Count;
					//
					// Utilizamos un ArrayList como almacén temporal de la lista de archivos del ListBox
					// - pasamos al ArrayList los elementos del ListBox cuyo nombre termina en la extensión buscada
					// - vaciamos el ListBox
					// - volcamos el ArrayList al ListBox con los elementos encontrados
					ArrayList matriz = new ArrayList();
					int indice = 0;
					//
					for (indice = 0; indice <= listBox.Items.Count - 1; indice++)
					{
						if (Convert.ToString(listBox.Items[indice]).EndsWith("." + txtExt1.Text, StringComparison.CurrentCultureIgnoreCase))
						{
							matriz.Add(Convert.ToString(listBox.Items[indice]));
						}
					}
					listBox.Items.Clear();
					//
					for (indice = 0; indice <= matriz.Count - 1; indice++)
					{
						listBox.Items.Add(matriz[indice]);
					}
					//
					// Información en la barra de título
					j = listBox.Items.Count;
					this.Text = "Archivos ." + txtExt1.Text + ": " + Convert.ToString(j);
					//
					final = System.Environment.TickCount;
					MessageBox.Show("Tiempo utilizado en el proceso: " + Convert.ToString((double) (final - inicio) / 1000) + " segundos.");
					//
				}
				else
				{
					if (a == true)
					{
						MessageBox.Show("Falta la extensión para la búsqueda");
					}
				}
				//
			}
			catch (Exception pollo)
			{
				if (!(pollo.GetType().ToString() == "System.UnauthorizedAccessException"))
				{
					MessageBox.Show(System.Convert.ToString("Se ha producido una excepción:" + "\r\n" + pollo.GetType().ToString() +"."));
				}
			}
		}
		
		private void BtSalir_Click(System.Object sender, System.EventArgs e)
		{
			this.Close();
		}
		
	}
	
}
